/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import com.rjconsultores.ventaboletos.entidad.DiagramaAutobus;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderDiagramaAutobus;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Intbox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("busquedaDiagramaAutobusController")
@Scope("prototype")
public class BusquedaDiagramaAutobusController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<DiagramaAutobus> plwDiagramaAutobus;
    private MyListbox diagramaAutobusList;
    private Paging pagingDiagramaAutobus;
    private Textbox txtNome;
    private Intbox txtCantasientos;

    public Intbox getTxtCantasientos() {
        return txtCantasientos;
    }

    public void setTxtCantasientos(Intbox txtCantasientos) {
        this.txtCantasientos = txtCantasientos;
    }

    public MyListbox getDiagramaAutobusList() {
        return diagramaAutobusList;
    }

    public void setDiagramaAutobusList(MyListbox diagramaAutobusList) {
        this.diagramaAutobusList = diagramaAutobusList;
    }

    public Paging getPagingDiagramaAutobus() {
        return pagingDiagramaAutobus;
    }

    public void setPagingDiagramaAutobus(Paging pagingDiagramaAutobus) {
        this.pagingDiagramaAutobus = pagingDiagramaAutobus;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        diagramaAutobusList.setItemRenderer(new RenderDiagramaAutobus());
        diagramaAutobusList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                DiagramaAutobus d = (DiagramaAutobus) diagramaAutobusList.getSelected();
                verDiagramaAutobus(d);
            }
        });

        refreshLista();

        txtNome.focus();
    }

    private void verDiagramaAutobus(DiagramaAutobus d) {
        if (d == null) {
            return;
        }

        txtNome.setText("");
        txtCantasientos.setValue(null);

        Map args = new HashMap();
        args.put("diagramaAutobus", d);
        args.put("diagramaAutobusList", diagramaAutobusList);

        openWindow("/gui/esquema_operacional/editarDiagramaAutobus.zul",
                Labels.getLabel("editarDiagramaAutobusController.window.title"),
                args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<DiagramaAutobus> diagramaAutobusbusqueda =
                new HibernateSearchObject<DiagramaAutobus>(DiagramaAutobus.class,
                pagingDiagramaAutobus.getPageSize());

        diagramaAutobusbusqueda.addFilterLike("descDiagrama",
                "%" + txtNome.getText().trim().concat("%"));
        diagramaAutobusbusqueda.addFilterEqual("cantasientos",
                txtCantasientos.getValue());

        diagramaAutobusbusqueda.addSortAsc("descDiagrama");
        diagramaAutobusbusqueda.addFilterEqual("activo", Boolean.TRUE);

        plwDiagramaAutobus.init(diagramaAutobusbusqueda, diagramaAutobusList,
                pagingDiagramaAutobus);

        if (diagramaAutobusList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaDiagramaAutobusController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public void onClick$btnPesquisa(Event ev) {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verDiagramaAutobus(new DiagramaAutobus());
    }
}
